/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Jan. 2007

 File          : WU.c

 Hardware      : Applicable to ADuC703x

 Description   : 
		
*********************************************************************/

#include <ADuC7033.h>

typedef enum IgnitionState { OFF, ON } ign_state;
ign_state	ignStarter;

void delay(int);
void My_IRQ_Function(void);				//	IRQ Funtion Prototype 

int main()
{
	char HVstatus;
	do
	{
		HVDAT = 0x10; 					// Enable WU
		HVCON = 0x09; 					// Write to Config1
		do
		{
			HVstatus = HVCON;
		}
		while(HVstatus & 0x1); 			// Wait until command is finished
	}
	while (!(HVstatus & 0x4));			// Transmit command is correct

	IRQ = My_IRQ_Function;				// Specify Interrupt Service Rountine 
	GP2DAT = 0x02000000;				// Enable P2.1 (GPIO8) as an output
	IRQEN = 0x10000;					// Enable HV interrupt
	while (1)
	{
		delay(200000);
	}				
}

void My_IRQ_Function()
{
	char HVstatus;
	short a;
	int iIRQ_Source;
	iIRQ_Source = IRQSTA;				// Save a temporary copy of IRQSTA
	if ((iIRQ_Source & 0x10000) != 0)
	{
		do
		{					
			HVCON = 0x02; 					// Read HVSTA
			do
			{
				HVstatus = HVCON;
			}
			while (HVstatus & 0x1); 			// Wait until command is finished
		}
		while (!(HVstatus & 0x2));			// Read command is correct
		a = HVDAT; 	
		if ((a&0x10)!=0)
		{
			ignStarter = ON;
		}
		else ignStarter = OFF;
		GP2DAT ^=0x020000;					// Complement P2.1
	} 				
	return;
}

void delay (int length)
{
   	while (length >=0)
    	length--;
}
